c  Program to identify offsets and 'glitches' in time series
c    data

      dimension yr(300000), doy(300000), d(300000),
     & off(300000),spike(300000),clip(300000),time(300000)
      double precision doy, time, deltat,dt
      character*40 finput
      max=300000
      print*,' Input the name of the file with the data'
      read(5,100)finput
      open(1,file=finput)
100   format(a40)
      print*, "Input the threshold for offsets and spike"
      read(5,*) thres1
      print*,"Input the threshold for max/min values for clipping;',
     &  ' two numbers"
      read(5,*) thres2a, thres2b
      threshi=thres2a
      threslo=thres2b
      if ( threslo .gt. threshi) then
        threshi=thres2b
        threslo=thres2a
      end if
      i=1
      dt=99999.d+0
1     continue
      read(1,*,end=5)yr(i), doy(i), d(i),e
      call jul2day(int(yr(i)),int(doy(i)),iday)
      time(i)=float(iday)+doy(i)-float(int(doy(i)))
      if (i .ne. 1) then
         deltat=time(i)-time(i-1)
         if (deltat .lt. dt) dt=deltat
      end if
      i=i+1
      if (i .gt. max) then
        print*,' Number of data read,', i, ' exceeds the dimensions',
     &        max
      end if
      go to 1
5     continue
      npts=i-1
      print*, ' Number of data read is', npts
      print*,' minumum sampling interval, days', dt
      idt=int(24.0*60.0*dt+0.1)

      print*,' minumum sampling interval in minutes', idt
      dt=float(idt)/(2.0d+0*60.0d+0*24.0d+0)
      print*,dt
      open(2,file="clip.out")
c   identify date > thres2; delete the from list
      nclip=0
      do 10 i=1,npts
      if (( d(i) .gt. threshi )  .or. ( d(i) .lt. threslo ) )  then
         call invcal(int(time(i)-dt),iyr1,imn1,ida1)
         ihr1=int(24.0*(time(i)-dt-int(time(i)-dt))+0.001)
         mn1=int(60.*((24.0*(time(i)-dt-int(time(i)-dt))+0.001) - 
     &     float(ihr1)) + 0.01 )  
         call invcal(int(time(i)+dt),iyr2,imn2,ida2)
         ihr2=int(24.0*(time(i)+dt-int(time(i)+dt))+0.001)
         mn2=int(60.*((24.0*(time(i)+dt-int(time(i)+dt))+0.001) - 
     &     float(ihr2)) + 0.01 )  
         write(2,101)yr(i),doy(i),d(i), iyr1,imn1,ida1,ihr1,mn1,
     &    iyr2,imn2,ida2,ihr2,mn2
101      format( f6.0, f15.9, f15.3, 5x, i5,i2.2,i2.2,i2.2,i2.2,
     &   3x,i5,i2.2,i2.2,i2.2,i2.2)
         nclip=nclip+1
         do 11 k=i+1,npts-nclip+1
           yr(k-1)=yr(k)
           doy(k-1)=doy(k)
           d(k-1)=d(k)
           time(k-1)=time(k)
11       continue
      end if
10    continue
      print*," Found ", nclip, " data that are clipped"
      print*,"  times of clipped data in clip.out"
      print*," "
      close(2)
      open(2,file="spike_off.out")

c  fit a 4 point offset and a 3 point spike to the data
      spike(2)=d(2)-0.5*(d(1)+d(3))
      off(2)=0.
      
      do 15 i=3,npts-2
        spike(i)=d(i)-0.5*(d(i-1)+d(i+1))
        off(i)=0.5*(d(i)+d(i+1))-0.5*(d(i-1)+d(i-2))
15    continue
      spike(npts-1)=d(npts-1)-0.5*(d(npts)+d(npts-2))
      off(npts-1)=0.

      nn=0
      do 20 i=2,npts
        if ( (abs(off(i)) .gt. thres1) .or. 
     &      (abs(spike(i)) .gt. thres1) ) then
         call invcal(int(time(i)-dt),iyr1,imn1,ida1)
         ihr1=int(24.0*(time(i)-dt-int(time(i)-dt))+0.001)
         mn1=int(60.*((24.0*(time(i)-dt-int(time(i)-dt))+0.001) - 
     &     float(ihr1)) + 0.01 )  
         call invcal(int(time(i)+dt),iyr2,imn2,ida2)
         ihr2=int(24.0*(time(i)+dt-int(time(i)+dt))+0.001)
         mn2=int(60.*((24.0*(time(i)+dt-int(time(i)+dt))+0.001) - 
     &     float(ihr2)) + 0.01 )  
          write(2,102)yr(i),doy(i),d(i),off(i),spike(i),
     &    iyr1,imn1,ida1,ihr1,mn1,
     &    iyr2,imn2,ida2,ihr2,mn2
102       format(f6.0,f15.9,' obs=',f15.3,' offset=', f10.0,
     &   ' spike=', f10.0,
     &    5x,i5,i2.2,i2.2,i2.2,i2.2,
     &    3x,i5,i2.2,i2.2,i2.2,i2.2)
          nn=nn+1
        end if
20    continue
      close(1)
      close(2)
      print*,' times of possible offset/spikes in spike_off.out'
      print*,'  Number of possilbe offsets/spikes is', nn
      stop
      end
      subroutine jul2day(yr,jul,iday)
      integer yr, jul, iday
      yr=yr-1900
      iday=0
      if (yr .gt. 60 ) iday=iday+1
      if (yr .gt. 64 ) iday=iday+1
      if (yr .gt. 68 ) iday=iday+1
      if (yr .gt. 72 ) iday=iday+1
      if (yr .gt. 76 ) iday=iday+1
      if (yr .gt. 80 ) iday=iday+1
      if (yr .gt. 84 ) iday=iday+1
      if (yr .gt. 88 ) iday=iday+1
      if (yr .gt. 92 ) iday=iday+1
      if (yr .gt. 96 ) iday=iday+1
      if (yr .gt. 100 ) iday=iday+1
      if (yr .gt. 104 ) iday=iday+1
      if (yr .gt. 108 ) iday=iday+1
      if (yr .gt. 112 ) iday=iday+1
      if (yr .gt. 116 ) iday=iday+1

 
      iday=iday+(yr-60)*365 + jul
      yr=yr+1900
      return
      end
                                                                                
       subroutine invcal(day,yr1,mn,date)
c
c inverse calender function
c
c  give day number relative to jan 1, 1980
c  output dat yr, month and day
c
       integer day,yr,mn,date,yr1
       integer year(60),month(22),lmnth(22)
c       data (year(i),i=1,20)/0,366,731,1096,1462,1827,2192,2557,2923,
c     1  3288,3653,4018,4384,4749,5114,5479,5845,6210,6575,6940/
       data (month(i),i=1,13)/0,31,59,90,120,151,181,212,243,273,304,
     1                           334,365/
       data (lmnth(i),i=1,13)/0,31,60,91,121,152,182,213,244,274,305,
     1                          335,366/
       icnt=-365
       icnt=-364
       do 40 j=1,60
         jj=j+2
         xx=float(jj)/4 - (ifix(jj/4.))
         if (xx .ne. 0) add=365
         if (xx .eq. 0) add=366
c         ixx=ifix(jj/4.) - int(jj/4)
c         if (ixx .ne. 0) add=365
c         if (ixx .eq. 0) add=366
         icnt=icnt+add
         year(j)=icnt
c         print*,j,year(j)
40     continue
                                                                                
c select the year
       yr=0
1      continue
       if (day .lt. year(yr+1)) go to 5
       yr=yr+1
       go to 1
5      continue
       yr=yr-1
       id=day-year(yr+1)+1
       yr=yr+60
       yr1=yr+1900
c  leap year sense
       if ((yr .eq. 80) .or. (yr .eq. 84) .or. (yr .eq. 88) .or.
     & (yr .eq. 92) .or. (yr .eq. 96) .or. (yr .eq. 100) .or.
     & (yr .eq. 104) .or. (yr .eq. 108) .or. (yr .eq. 112) .or.
     & (yr .eq. 116) .or.
     & (yr .eq. 60) .or. (yr .eq. 64) .or. (yr .eq. 68) .or.
     & (yr .eq. 72) .or. (yr .eq. 76)) go to 20
c  select the month
       mn=1
7      continue
c       print*,id,month(mn)
       if (id .le. month(mn)) go to 10
       mn=mn+1
       go to 7
10     mn=mn-1
       date=id-month(mn)
       return
c  select month for the leap year
20     continue
       mn=1
27     continue
       if (id .le. lmnth(mn)) go to 30
       mn=mn+1
       go to 27
30     mn=mn-1
       date=id-lmnth(mn)
       return
       end
